#!/usr/bin/env python
#encoding: utf-8
import pygtk
pygtk.require('2.0')
import gtk
import os
import os.path
import sys
import tempfile
import time
from subprocess import Popen

def run_action(btn, act):
	Popen(act)

class Window(gtk.Window):
	def __init__(self, filename, *args, **kwargs):
		gtk.Window.__init__(self, *args, **kwargs)
		self.set_title(os.path.basename(filename))
		self.set_icon_name("love")
		self.set_keep_above(True)
		self.set_resizable(False)
		self.directory = tempfile.mkdtemp()
		self.filename = filename
		Popen(["fuse-zip", self.filename, self.directory])
		box = gtk.VBox(spacing=8)
		box.set_border_width(8)
		self.add_button(box, "Open directory", ["gnome-open", self.directory])
		self.add_button(box, "Open main.lua", ["gnome-open", self.directory + '/main.lua'])
		self.add_button(box, "Run LÖVE", ["love", self.directory])
		b = gtk.Button("Unmount")
		b.show()
		b.connect("clicked", self.close)
		box.add(b)
		box.show()
		self.add(box)
		self.connect('delete-event', self.on_close)
		self.show()
	def add_button(self, box, title, action):
		b = gtk.Button(title)
		b.show()
		b.connect("clicked", run_action, action)
		box.add(b)
	def close(self, btn):
		self.on_close()
		gtk.main_quit()
	def on_close(self, wnd=None, act=None):
		Popen(["fusermount", "-u", self.directory])
		while True:
			time.sleep(.1)
			try:
				os.rmdir(self.directory)
			except OSError:
				pass
			else:
				break

if __name__ == '__main__':
	if len(sys.argv) > 1 and os.path.exists(sys.argv[1]):
		w = Window(sys.argv[1], gtk.WINDOW_TOPLEVEL)
		w.connect("destroy", gtk.main_quit)
		gtk.main()
